package com.sztzjy.money_management.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class CaseCashFlowExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CaseCashFlowExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andCaseCashFlowIdIsNull() {
            addCriterion("case_cash_flow_id is null");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdIsNotNull() {
            addCriterion("case_cash_flow_id is not null");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdEqualTo(String value) {
            addCriterion("case_cash_flow_id =", value, "caseCashFlowId");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdNotEqualTo(String value) {
            addCriterion("case_cash_flow_id <>", value, "caseCashFlowId");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdGreaterThan(String value) {
            addCriterion("case_cash_flow_id >", value, "caseCashFlowId");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdGreaterThanOrEqualTo(String value) {
            addCriterion("case_cash_flow_id >=", value, "caseCashFlowId");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdLessThan(String value) {
            addCriterion("case_cash_flow_id <", value, "caseCashFlowId");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdLessThanOrEqualTo(String value) {
            addCriterion("case_cash_flow_id <=", value, "caseCashFlowId");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdLike(String value) {
            addCriterion("case_cash_flow_id like", value, "caseCashFlowId");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdNotLike(String value) {
            addCriterion("case_cash_flow_id not like", value, "caseCashFlowId");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdIn(List<String> values) {
            addCriterion("case_cash_flow_id in", values, "caseCashFlowId");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdNotIn(List<String> values) {
            addCriterion("case_cash_flow_id not in", values, "caseCashFlowId");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdBetween(String value1, String value2) {
            addCriterion("case_cash_flow_id between", value1, value2, "caseCashFlowId");
            return (Criteria) this;
        }

        public Criteria andCaseCashFlowIdNotBetween(String value1, String value2) {
            addCriterion("case_cash_flow_id not between", value1, value2, "caseCashFlowId");
            return (Criteria) this;
        }

        public Criteria andCaseidIsNull() {
            addCriterion("caseid is null");
            return (Criteria) this;
        }

        public Criteria andCaseidIsNotNull() {
            addCriterion("caseid is not null");
            return (Criteria) this;
        }

        public Criteria andCaseidEqualTo(String value) {
            addCriterion("caseid =", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotEqualTo(String value) {
            addCriterion("caseid <>", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidGreaterThan(String value) {
            addCriterion("caseid >", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidGreaterThanOrEqualTo(String value) {
            addCriterion("caseid >=", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidLessThan(String value) {
            addCriterion("caseid <", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidLessThanOrEqualTo(String value) {
            addCriterion("caseid <=", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidLike(String value) {
            addCriterion("caseid like", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotLike(String value) {
            addCriterion("caseid not like", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidIn(List<String> values) {
            addCriterion("caseid in", values, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotIn(List<String> values) {
            addCriterion("caseid not in", values, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidBetween(String value1, String value2) {
            addCriterion("caseid between", value1, value2, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotBetween(String value1, String value2) {
            addCriterion("caseid not between", value1, value2, "caseid");
            return (Criteria) this;
        }

        public Criteria andProposalIdIsNull() {
            addCriterion("proposal_id is null");
            return (Criteria) this;
        }

        public Criteria andProposalIdIsNotNull() {
            addCriterion("proposal_id is not null");
            return (Criteria) this;
        }

        public Criteria andProposalIdEqualTo(String value) {
            addCriterion("proposal_id =", value, "proposalId");
            return (Criteria) this;
        }

        public Criteria andProposalIdNotEqualTo(String value) {
            addCriterion("proposal_id <>", value, "proposalId");
            return (Criteria) this;
        }

        public Criteria andProposalIdGreaterThan(String value) {
            addCriterion("proposal_id >", value, "proposalId");
            return (Criteria) this;
        }

        public Criteria andProposalIdGreaterThanOrEqualTo(String value) {
            addCriterion("proposal_id >=", value, "proposalId");
            return (Criteria) this;
        }

        public Criteria andProposalIdLessThan(String value) {
            addCriterion("proposal_id <", value, "proposalId");
            return (Criteria) this;
        }

        public Criteria andProposalIdLessThanOrEqualTo(String value) {
            addCriterion("proposal_id <=", value, "proposalId");
            return (Criteria) this;
        }

        public Criteria andProposalIdLike(String value) {
            addCriterion("proposal_id like", value, "proposalId");
            return (Criteria) this;
        }

        public Criteria andProposalIdNotLike(String value) {
            addCriterion("proposal_id not like", value, "proposalId");
            return (Criteria) this;
        }

        public Criteria andProposalIdIn(List<String> values) {
            addCriterion("proposal_id in", values, "proposalId");
            return (Criteria) this;
        }

        public Criteria andProposalIdNotIn(List<String> values) {
            addCriterion("proposal_id not in", values, "proposalId");
            return (Criteria) this;
        }

        public Criteria andProposalIdBetween(String value1, String value2) {
            addCriterion("proposal_id between", value1, value2, "proposalId");
            return (Criteria) this;
        }

        public Criteria andProposalIdNotBetween(String value1, String value2) {
            addCriterion("proposal_id not between", value1, value2, "proposalId");
            return (Criteria) this;
        }

        public Criteria andRedemptionIsNull() {
            addCriterion("redemption is null");
            return (Criteria) this;
        }

        public Criteria andRedemptionIsNotNull() {
            addCriterion("redemption is not null");
            return (Criteria) this;
        }

        public Criteria andRedemptionEqualTo(BigDecimal value) {
            addCriterion("redemption =", value, "redemption");
            return (Criteria) this;
        }

        public Criteria andRedemptionNotEqualTo(BigDecimal value) {
            addCriterion("redemption <>", value, "redemption");
            return (Criteria) this;
        }

        public Criteria andRedemptionGreaterThan(BigDecimal value) {
            addCriterion("redemption >", value, "redemption");
            return (Criteria) this;
        }

        public Criteria andRedemptionGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("redemption >=", value, "redemption");
            return (Criteria) this;
        }

        public Criteria andRedemptionLessThan(BigDecimal value) {
            addCriterion("redemption <", value, "redemption");
            return (Criteria) this;
        }

        public Criteria andRedemptionLessThanOrEqualTo(BigDecimal value) {
            addCriterion("redemption <=", value, "redemption");
            return (Criteria) this;
        }

        public Criteria andRedemptionIn(List<BigDecimal> values) {
            addCriterion("redemption in", values, "redemption");
            return (Criteria) this;
        }

        public Criteria andRedemptionNotIn(List<BigDecimal> values) {
            addCriterion("redemption not in", values, "redemption");
            return (Criteria) this;
        }

        public Criteria andRedemptionBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("redemption between", value1, value2, "redemption");
            return (Criteria) this;
        }

        public Criteria andRedemptionNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("redemption not between", value1, value2, "redemption");
            return (Criteria) this;
        }

        public Criteria andInvestmentIsNull() {
            addCriterion("investment is null");
            return (Criteria) this;
        }

        public Criteria andInvestmentIsNotNull() {
            addCriterion("investment is not null");
            return (Criteria) this;
        }

        public Criteria andInvestmentEqualTo(BigDecimal value) {
            addCriterion("investment =", value, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentNotEqualTo(BigDecimal value) {
            addCriterion("investment <>", value, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentGreaterThan(BigDecimal value) {
            addCriterion("investment >", value, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("investment >=", value, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentLessThan(BigDecimal value) {
            addCriterion("investment <", value, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentLessThanOrEqualTo(BigDecimal value) {
            addCriterion("investment <=", value, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentIn(List<BigDecimal> values) {
            addCriterion("investment in", values, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentNotIn(List<BigDecimal> values) {
            addCriterion("investment not in", values, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("investment between", value1, value2, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("investment not between", value1, value2, "investment");
            return (Criteria) this;
        }

        public Criteria andBorrowCapitalIsNull() {
            addCriterion("borrow_capital is null");
            return (Criteria) this;
        }

        public Criteria andBorrowCapitalIsNotNull() {
            addCriterion("borrow_capital is not null");
            return (Criteria) this;
        }

        public Criteria andBorrowCapitalEqualTo(BigDecimal value) {
            addCriterion("borrow_capital =", value, "borrowCapital");
            return (Criteria) this;
        }

        public Criteria andBorrowCapitalNotEqualTo(BigDecimal value) {
            addCriterion("borrow_capital <>", value, "borrowCapital");
            return (Criteria) this;
        }

        public Criteria andBorrowCapitalGreaterThan(BigDecimal value) {
            addCriterion("borrow_capital >", value, "borrowCapital");
            return (Criteria) this;
        }

        public Criteria andBorrowCapitalGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("borrow_capital >=", value, "borrowCapital");
            return (Criteria) this;
        }

        public Criteria andBorrowCapitalLessThan(BigDecimal value) {
            addCriterion("borrow_capital <", value, "borrowCapital");
            return (Criteria) this;
        }

        public Criteria andBorrowCapitalLessThanOrEqualTo(BigDecimal value) {
            addCriterion("borrow_capital <=", value, "borrowCapital");
            return (Criteria) this;
        }

        public Criteria andBorrowCapitalIn(List<BigDecimal> values) {
            addCriterion("borrow_capital in", values, "borrowCapital");
            return (Criteria) this;
        }

        public Criteria andBorrowCapitalNotIn(List<BigDecimal> values) {
            addCriterion("borrow_capital not in", values, "borrowCapital");
            return (Criteria) this;
        }

        public Criteria andBorrowCapitalBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("borrow_capital between", value1, value2, "borrowCapital");
            return (Criteria) this;
        }

        public Criteria andBorrowCapitalNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("borrow_capital not between", value1, value2, "borrowCapital");
            return (Criteria) this;
        }

        public Criteria andRepaymentCapitalIsNull() {
            addCriterion("repayment_capital is null");
            return (Criteria) this;
        }

        public Criteria andRepaymentCapitalIsNotNull() {
            addCriterion("repayment_capital is not null");
            return (Criteria) this;
        }

        public Criteria andRepaymentCapitalEqualTo(BigDecimal value) {
            addCriterion("repayment_capital =", value, "repaymentCapital");
            return (Criteria) this;
        }

        public Criteria andRepaymentCapitalNotEqualTo(BigDecimal value) {
            addCriterion("repayment_capital <>", value, "repaymentCapital");
            return (Criteria) this;
        }

        public Criteria andRepaymentCapitalGreaterThan(BigDecimal value) {
            addCriterion("repayment_capital >", value, "repaymentCapital");
            return (Criteria) this;
        }

        public Criteria andRepaymentCapitalGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("repayment_capital >=", value, "repaymentCapital");
            return (Criteria) this;
        }

        public Criteria andRepaymentCapitalLessThan(BigDecimal value) {
            addCriterion("repayment_capital <", value, "repaymentCapital");
            return (Criteria) this;
        }

        public Criteria andRepaymentCapitalLessThanOrEqualTo(BigDecimal value) {
            addCriterion("repayment_capital <=", value, "repaymentCapital");
            return (Criteria) this;
        }

        public Criteria andRepaymentCapitalIn(List<BigDecimal> values) {
            addCriterion("repayment_capital in", values, "repaymentCapital");
            return (Criteria) this;
        }

        public Criteria andRepaymentCapitalNotIn(List<BigDecimal> values) {
            addCriterion("repayment_capital not in", values, "repaymentCapital");
            return (Criteria) this;
        }

        public Criteria andRepaymentCapitalBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("repayment_capital between", value1, value2, "repaymentCapital");
            return (Criteria) this;
        }

        public Criteria andRepaymentCapitalNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("repayment_capital not between", value1, value2, "repaymentCapital");
            return (Criteria) this;
        }

        public Criteria andWorkIncomeIsNull() {
            addCriterion("work_income is null");
            return (Criteria) this;
        }

        public Criteria andWorkIncomeIsNotNull() {
            addCriterion("work_income is not null");
            return (Criteria) this;
        }

        public Criteria andWorkIncomeEqualTo(BigDecimal value) {
            addCriterion("work_income =", value, "workIncome");
            return (Criteria) this;
        }

        public Criteria andWorkIncomeNotEqualTo(BigDecimal value) {
            addCriterion("work_income <>", value, "workIncome");
            return (Criteria) this;
        }

        public Criteria andWorkIncomeGreaterThan(BigDecimal value) {
            addCriterion("work_income >", value, "workIncome");
            return (Criteria) this;
        }

        public Criteria andWorkIncomeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("work_income >=", value, "workIncome");
            return (Criteria) this;
        }

        public Criteria andWorkIncomeLessThan(BigDecimal value) {
            addCriterion("work_income <", value, "workIncome");
            return (Criteria) this;
        }

        public Criteria andWorkIncomeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("work_income <=", value, "workIncome");
            return (Criteria) this;
        }

        public Criteria andWorkIncomeIn(List<BigDecimal> values) {
            addCriterion("work_income in", values, "workIncome");
            return (Criteria) this;
        }

        public Criteria andWorkIncomeNotIn(List<BigDecimal> values) {
            addCriterion("work_income not in", values, "workIncome");
            return (Criteria) this;
        }

        public Criteria andWorkIncomeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("work_income between", value1, value2, "workIncome");
            return (Criteria) this;
        }

        public Criteria andWorkIncomeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("work_income not between", value1, value2, "workIncome");
            return (Criteria) this;
        }

        public Criteria andLiveExpenseIsNull() {
            addCriterion("live_expense is null");
            return (Criteria) this;
        }

        public Criteria andLiveExpenseIsNotNull() {
            addCriterion("live_expense is not null");
            return (Criteria) this;
        }

        public Criteria andLiveExpenseEqualTo(BigDecimal value) {
            addCriterion("live_expense =", value, "liveExpense");
            return (Criteria) this;
        }

        public Criteria andLiveExpenseNotEqualTo(BigDecimal value) {
            addCriterion("live_expense <>", value, "liveExpense");
            return (Criteria) this;
        }

        public Criteria andLiveExpenseGreaterThan(BigDecimal value) {
            addCriterion("live_expense >", value, "liveExpense");
            return (Criteria) this;
        }

        public Criteria andLiveExpenseGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("live_expense >=", value, "liveExpense");
            return (Criteria) this;
        }

        public Criteria andLiveExpenseLessThan(BigDecimal value) {
            addCriterion("live_expense <", value, "liveExpense");
            return (Criteria) this;
        }

        public Criteria andLiveExpenseLessThanOrEqualTo(BigDecimal value) {
            addCriterion("live_expense <=", value, "liveExpense");
            return (Criteria) this;
        }

        public Criteria andLiveExpenseIn(List<BigDecimal> values) {
            addCriterion("live_expense in", values, "liveExpense");
            return (Criteria) this;
        }

        public Criteria andLiveExpenseNotIn(List<BigDecimal> values) {
            addCriterion("live_expense not in", values, "liveExpense");
            return (Criteria) this;
        }

        public Criteria andLiveExpenseBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("live_expense between", value1, value2, "liveExpense");
            return (Criteria) this;
        }

        public Criteria andLiveExpenseNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("live_expense not between", value1, value2, "liveExpense");
            return (Criteria) this;
        }

        public Criteria andInvestIncomeIsNull() {
            addCriterion("invest_income is null");
            return (Criteria) this;
        }

        public Criteria andInvestIncomeIsNotNull() {
            addCriterion("invest_income is not null");
            return (Criteria) this;
        }

        public Criteria andInvestIncomeEqualTo(BigDecimal value) {
            addCriterion("invest_income =", value, "investIncome");
            return (Criteria) this;
        }

        public Criteria andInvestIncomeNotEqualTo(BigDecimal value) {
            addCriterion("invest_income <>", value, "investIncome");
            return (Criteria) this;
        }

        public Criteria andInvestIncomeGreaterThan(BigDecimal value) {
            addCriterion("invest_income >", value, "investIncome");
            return (Criteria) this;
        }

        public Criteria andInvestIncomeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("invest_income >=", value, "investIncome");
            return (Criteria) this;
        }

        public Criteria andInvestIncomeLessThan(BigDecimal value) {
            addCriterion("invest_income <", value, "investIncome");
            return (Criteria) this;
        }

        public Criteria andInvestIncomeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("invest_income <=", value, "investIncome");
            return (Criteria) this;
        }

        public Criteria andInvestIncomeIn(List<BigDecimal> values) {
            addCriterion("invest_income in", values, "investIncome");
            return (Criteria) this;
        }

        public Criteria andInvestIncomeNotIn(List<BigDecimal> values) {
            addCriterion("invest_income not in", values, "investIncome");
            return (Criteria) this;
        }

        public Criteria andInvestIncomeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("invest_income between", value1, value2, "investIncome");
            return (Criteria) this;
        }

        public Criteria andInvestIncomeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("invest_income not between", value1, value2, "investIncome");
            return (Criteria) this;
        }

        public Criteria andInterestExpenseIsNull() {
            addCriterion("interest_expense is null");
            return (Criteria) this;
        }

        public Criteria andInterestExpenseIsNotNull() {
            addCriterion("interest_expense is not null");
            return (Criteria) this;
        }

        public Criteria andInterestExpenseEqualTo(BigDecimal value) {
            addCriterion("interest_expense =", value, "interestExpense");
            return (Criteria) this;
        }

        public Criteria andInterestExpenseNotEqualTo(BigDecimal value) {
            addCriterion("interest_expense <>", value, "interestExpense");
            return (Criteria) this;
        }

        public Criteria andInterestExpenseGreaterThan(BigDecimal value) {
            addCriterion("interest_expense >", value, "interestExpense");
            return (Criteria) this;
        }

        public Criteria andInterestExpenseGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("interest_expense >=", value, "interestExpense");
            return (Criteria) this;
        }

        public Criteria andInterestExpenseLessThan(BigDecimal value) {
            addCriterion("interest_expense <", value, "interestExpense");
            return (Criteria) this;
        }

        public Criteria andInterestExpenseLessThanOrEqualTo(BigDecimal value) {
            addCriterion("interest_expense <=", value, "interestExpense");
            return (Criteria) this;
        }

        public Criteria andInterestExpenseIn(List<BigDecimal> values) {
            addCriterion("interest_expense in", values, "interestExpense");
            return (Criteria) this;
        }

        public Criteria andInterestExpenseNotIn(List<BigDecimal> values) {
            addCriterion("interest_expense not in", values, "interestExpense");
            return (Criteria) this;
        }

        public Criteria andInterestExpenseBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("interest_expense between", value1, value2, "interestExpense");
            return (Criteria) this;
        }

        public Criteria andInterestExpenseNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("interest_expense not between", value1, value2, "interestExpense");
            return (Criteria) this;
        }

        public Criteria andInsuranceExpenseIsNull() {
            addCriterion("insurance_expense is null");
            return (Criteria) this;
        }

        public Criteria andInsuranceExpenseIsNotNull() {
            addCriterion("insurance_expense is not null");
            return (Criteria) this;
        }

        public Criteria andInsuranceExpenseEqualTo(BigDecimal value) {
            addCriterion("insurance_expense =", value, "insuranceExpense");
            return (Criteria) this;
        }

        public Criteria andInsuranceExpenseNotEqualTo(BigDecimal value) {
            addCriterion("insurance_expense <>", value, "insuranceExpense");
            return (Criteria) this;
        }

        public Criteria andInsuranceExpenseGreaterThan(BigDecimal value) {
            addCriterion("insurance_expense >", value, "insuranceExpense");
            return (Criteria) this;
        }

        public Criteria andInsuranceExpenseGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("insurance_expense >=", value, "insuranceExpense");
            return (Criteria) this;
        }

        public Criteria andInsuranceExpenseLessThan(BigDecimal value) {
            addCriterion("insurance_expense <", value, "insuranceExpense");
            return (Criteria) this;
        }

        public Criteria andInsuranceExpenseLessThanOrEqualTo(BigDecimal value) {
            addCriterion("insurance_expense <=", value, "insuranceExpense");
            return (Criteria) this;
        }

        public Criteria andInsuranceExpenseIn(List<BigDecimal> values) {
            addCriterion("insurance_expense in", values, "insuranceExpense");
            return (Criteria) this;
        }

        public Criteria andInsuranceExpenseNotIn(List<BigDecimal> values) {
            addCriterion("insurance_expense not in", values, "insuranceExpense");
            return (Criteria) this;
        }

        public Criteria andInsuranceExpenseBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("insurance_expense between", value1, value2, "insuranceExpense");
            return (Criteria) this;
        }

        public Criteria andInsuranceExpenseNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("insurance_expense not between", value1, value2, "insuranceExpense");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(String value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(String value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(String value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(String value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(String value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLike(String value) {
            addCriterion("user_id like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotLike(String value) {
            addCriterion("user_id not like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<String> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<String> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(String value1, String value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(String value1, String value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIsNull() {
            addCriterion("is_answer is null");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIsNotNull() {
            addCriterion("is_answer is not null");
            return (Criteria) this;
        }

        public Criteria andIsAnswerEqualTo(String value) {
            addCriterion("is_answer =", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotEqualTo(String value) {
            addCriterion("is_answer <>", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerGreaterThan(String value) {
            addCriterion("is_answer >", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerGreaterThanOrEqualTo(String value) {
            addCriterion("is_answer >=", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLessThan(String value) {
            addCriterion("is_answer <", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLessThanOrEqualTo(String value) {
            addCriterion("is_answer <=", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLike(String value) {
            addCriterion("is_answer like", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotLike(String value) {
            addCriterion("is_answer not like", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIn(List<String> values) {
            addCriterion("is_answer in", values, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotIn(List<String> values) {
            addCriterion("is_answer not in", values, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerBetween(String value1, String value2) {
            addCriterion("is_answer between", value1, value2, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotBetween(String value1, String value2) {
            addCriterion("is_answer not between", value1, value2, "isAnswer");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}