package com.sztzjy.money_management.entity;

import io.swagger.annotations.ApiModelProperty;
/**
 * 保险产品表
 *
 * @author xcj
 * insurance_pro
 */
public class InsuranceProWithBLOBs extends InsurancePro {
    @ApiModelProperty("产品特色")
    private String features;

    @ApiModelProperty("产品详情")
    private String details;

    @ApiModelProperty("注意事项")
    private String attention;

    @ApiModelProperty("保险金申请")
    private String insuranceApplication;

    @ApiModelProperty("释义")
    private String paraphrase;

    @ApiModelProperty("典型案例")
    private String typicalCase;

    @ApiModelProperty("详细条件URL")
    private String detailConditionContent;

    public String getFeatures() {
        return features;
    }

    public void setFeatures(String features) {
        this.features = features == null ? null : features.trim();
    }

    public String getDetails() {
        return details;
    }

    public void setDetails(String details) {
        this.details = details == null ? null : details.trim();
    }

    public String getAttention() {
        return attention;
    }

    public void setAttention(String attention) {
        this.attention = attention == null ? null : attention.trim();
    }

    public String getInsuranceApplication() {
        return insuranceApplication;
    }

    public void setInsuranceApplication(String insuranceApplication) {
        this.insuranceApplication = insuranceApplication == null ? null : insuranceApplication.trim();
    }

    public String getParaphrase() {
        return paraphrase;
    }

    public void setParaphrase(String paraphrase) {
        this.paraphrase = paraphrase == null ? null : paraphrase.trim();
    }

    public String getTypicalCase() {
        return typicalCase;
    }

    public void setTypicalCase(String typicalCase) {
        this.typicalCase = typicalCase == null ? null : typicalCase.trim();
    }

    public String getDetailConditionContent() {
        return detailConditionContent;
    }

    public void setDetailConditionContent(String detailConditionContent) {
        this.detailConditionContent = detailConditionContent == null ? null : detailConditionContent.trim();
    }
}