package com.sztzjy.money_management.entity;

import java.util.Date;

import io.swagger.annotations.ApiModelProperty;
/**
 * 资源中心表
 *
 * @author xcj
 * resource_center
 */
public class ResourceCenter {
    @ApiModelProperty("资源ID")
    private String resourceCenterId;

    @ApiModelProperty("资源名称")
    private String resourceName;

    @ApiModelProperty("添加时间")
    private Date addTime;

    @ApiModelProperty("章节ID")
    private String chapterId;

    @ApiModelProperty("来源（学校ID/999999999）")
    private String source;

    @ApiModelProperty("文件类型")
    private String type;

    @ApiModelProperty("资源地址")
    private String resourceUrl;

    public String getResourceCenterId() {
        return resourceCenterId;
    }

    public void setResourceCenterId(String resourceCenterId) {
        this.resourceCenterId = resourceCenterId == null ? null : resourceCenterId.trim();
    }

    public String getResourceName() {
        return resourceName;
    }

    public void setResourceName(String resourceName) {
        this.resourceName = resourceName == null ? null : resourceName.trim();
    }

    public Date getAddTime() {
        return addTime;
    }

    public void setAddTime(Date addTime) {
        this.addTime = addTime;
    }

    public String getChapterId() {
        return chapterId;
    }

    public void setChapterId(String chapterId) {
        this.chapterId = chapterId == null ? null : chapterId.trim();
    }

    public String getSource() {
        return source;
    }

    public void setSource(String source) {
        this.source = source == null ? null : source.trim();
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type == null ? null : type.trim();
    }

    public String getResourceUrl() {
        return resourceUrl;
    }

    public void setResourceUrl(String resourceUrl) {
        this.resourceUrl = resourceUrl == null ? null : resourceUrl.trim();
    }
}