package com.sztzjy.money_management.entity.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @Author xcj
 * @Date 2024/8/26
 */
@Data
public class StuAuthTestDto{
    @ApiModelProperty("姓名")
    private String name;

    @ApiModelProperty("考试时间")
    private Date examTime;

    @ApiModelProperty("考试用时")
    private Integer examDuration;

    @ApiModelProperty("单选题ID列表")
    private String singleIds;

    @ApiModelProperty("多选题ID列表")
    private String multipleIds;

    @ApiModelProperty("判断题ID列表")
    private String judgeIds;

    @ApiModelProperty("单选题学生答案")
    private String singleStuAnswer;

    @ApiModelProperty("多选题学生答案")
    private String multipleStuAnswer;

    @ApiModelProperty("判断题学生答案")
    private String judgeStuAnswer;

    @ApiModelProperty("错误题目ID列表")
    private String errorIds;

    @ApiModelProperty("理论考试/理论知识/专业能力/公共基础/个人理财/风险管理/公司信贷/个人贷款")
    private String source;

    private List<CalcAuthScore> calcAuthScoreList;

    @ApiModelProperty("总分")
    private BigDecimal totalScore;
}
